## ros-indigo-frontier-exploration 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(frontier_exploration)

find_package(catkin REQUIRED COMPONENTS
  costmap_2d
  dynamic_reconfigure
  move_base_msgs
  geometry_msgs
  roscpp
  std_msgs
  tf
  actionlib
  actionlib_msgs
  visualization_msgs
  message_generation
)

find_package(Boost REQUIRED)
find_package(PCL REQUIRED COMPONENTS common)

add_message_files(
  FILES
  Frontier.msg
)

add_service_files(
  FILES
  UpdateBoundaryPolygon.srv
  GetNextFrontier.srv
)

add_action_files(
  FILES
  ExploreTask.action
)

generate_messages(
  DEPENDENCIES
  geometry_msgs std_msgs  actionlib_msgs move_base_msgs visualization_msgs
)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES explore_costmap
  CATKIN_DEPENDS
    costmap_2d
    dynamic_reconfigure
    geometry_msgs
    roscpp
    tf
    actionlib
  DEPENDS
    PCL
    Boost
)

include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS} ${PCL_INCLUDE_DIRS})

add_library(explore_costmap plugins/bounded_explore_layer.cpp src/frontier_search.cpp)
target_link_libraries(explore_costmap ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(explore_costmap ${PROJECT_NAME}_generate_messages_cpp ${catkin_EXPORTED_TARGETS})

add_executable(explore_server src/explore_server.cpp)
target_link_libraries(explore_server ${catkin_LIBRARIES})
add_dependencies(explore_server ${PROJECT_NAME}_generate_messages_cpp ${catkin_EXPORTED_TARGETS})

add_executable(explore_client src/explore_client.cpp)
target_link_libraries(explore_client ${catkin_LIBRARIES})
add_dependencies(explore_client ${PROJECT_NAME}_generate_messages_cpp ${catkin_EXPORTED_TARGETS})

if(CATKIN_ENABLE_TESTING)
  # Find package test dependencies
  find_package(rostest REQUIRED)
  find_package(gtest)


  # Add the test folder to the include directories
  include_directories(src/test)

  include_directories(${GTEST_INCLUDE_DIRS})
  link_directories(${GTEST_LIBRARY_DIRS})

  catkin_add_gtest(frontier_search_tests src/test/frontier_search_tests.cpp)
  target_link_libraries(frontier_search_tests explore_costmap)

  catkin_add_gtest(geometry_tools_tests src/test/geometry_tools_tests.cpp)
  target_link_libraries(geometry_tools_tests explore_costmap)

  catkin_add_gtest(costmap_tools_tests src/test/costmap_tools_tests.cpp)
  target_link_libraries(costmap_tools_tests explore_costmap)

endif()

install(TARGETS explore_server explore_client
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(TARGETS explore_costmap
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
        PATTERN ".svn" EXCLUDE)

install(DIRECTORY launch/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
        PATTERN ".svn" EXCLUDE)

install(FILES costmap_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-indigo-frontier-exploration (0.3.0-0trusty) trusty; urgency=high

  * adjust costmap lock to new interface
  * Contributors: Michael Görner

 -- Paul Bovbel <paul@bovbel.com>  Mon, 04 May 2015 04:00:00 -0000

ros-indigo-frontier-exploration (0.2.5-0trusty) trusty; urgency=high

  * Remove lazy initialization
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Wed, 08 Apr 2015 04:00:00 -0000

ros-indigo-frontier-exploration (0.2.4-0trusty) trusty; urgency=high

  * Fix compiler optimization issue where perimeter is always 0
  * Allow empty polygon goals for unbounded exploration
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Wed, 08 Apr 2015 04:00:00 -0000

ros-indigo-frontier-exploration (0.2.3-0trusty) trusty; urgency=high

  * Improve explore client user feedback
  * removed common_msgs depency
    since depending on metapackages is deprecated and all needed subpackages are included anyways
  * Add travis builds
  * Contributors: Henning Deeken, Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Mon, 23 Feb 2015 05:00:00 -0000

ros-indigo-frontier-exploration (0.2.2-0trusty) trusty; urgency=high

  * clean up conditionals and comments for more logical flow
  * switch to shared from raw ptr
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Sat, 13 Sep 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.2.1-0trusty) trusty; urgency=high

  * Update example launch files
  * Update package.xml
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Tue, 15 Apr 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.2.0-0trusty) trusty; urgency=high

  * rename test file
  * add more costmap_tools tests
  * refactor with frontier_search strategy object
  * remove calls to parent costmap instance
  * refactored to raii
  * fix gmapping compatibility using new "explore_clear_space" parameter
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Fri, 04 Apr 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.1.9-0trusty) trusty; urgency=high

  * fix regression
  * refactor for testing
  * fix stuck movement with 0 frequency
  * new launch file examples
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Wed, 02 Apr 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.1.8-0trusty) trusty; urgency=high

  * revert launch file to general form
  * document helper functions
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Fri, 28 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.1.4-0trusty) trusty; urgency=high

  * fix properly transforming robot position into goal frame
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Thu, 27 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.1.3-0trusty) trusty; urgency=high

  * revert redundant dependency
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Thu, 27 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.1.2-0trusty) trusty; urgency=high

  * fix message dependencies
  * fix goal aliasing corner case
  * fix empty frame name
  * Update README.md
  * accomodate for empty boundaries
  * parametrize goal aliasing for redundant move base goals
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Thu, 27 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.1.1-0trusty) trusty; urgency=high

  * fix build dependency
  * eliminate redundant move_base goal updates, fix locking
  * externalize static for geometric calculations
  * refactor action server with callbacks
  * fix pre-emption with continuous goal updating
  * implement continuous frontier/goal updating
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Wed, 26 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.1.0-0trusty) trusty; urgency=high

  * added install target for client
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Tue, 25 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.0.4-0trusty) trusty; urgency=high

  * remove robot specific names
  * remove raytrace and obstacle range params
  * reintroduce frontier selection parametrization
  * added client for rviz interaction via point tool
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Tue, 25 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.0.3-0trusty) trusty; urgency=high

  * parametrize method of selecting frontier point to travel to
  * use ros msg for Frontier structure
  * remove unnecessary costmap copying
  * remove debug messages, update comments
  * update package name
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Tue, 25 Mar 2014 04:00:00 -0000

ros-indigo-frontier-exploration (0.0.2-0trusty) trusty; urgency=high

  * fix locking issue
  * rename package
  * update dependencies
  * move sample parameters to launch file
  * remove temp files
  * refactoring
  * fix off-map error and add costmap locking
  * added resize parameter for working with external maps
  * refactor message fields
  * refactored message names
  * add resize parameter for using layer with external maps
  * refactor names
  * remove even more debug code
  * remove debug code
  * remove debug points
  * Updated maintainer info
  * Update documentation and comments
  * move test portion
  * refactor for pre-emption
  * clean up temp files
  * expanded comments, cleaned up temp files
  * Initial documentation
  * Initial commit
  * Contributors: Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Fri, 21 Mar 2014 04:00:00 -0000

=== debian/control ===
Source: ros-indigo-frontier-exploration
Section: misc
Priority: extra
Maintainer: Paul Bovbel <paul@bovbel.com>
Build-Depends: debhelper (>= 9.0.0), libpcl-1.7-all-dev, ros-indigo-actionlib, ros-indigo-actionlib-msgs, ros-indigo-catkin, ros-indigo-costmap-2d, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-message-generation, ros-indigo-move-base-msgs, ros-indigo-roscpp, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-visualization-msgs
Homepage: http://ros.org/wiki/frontier_exploration
Standards-Version: 3.9.2

Package: ros-indigo-frontier-exploration
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcl-1.7-all, ros-indigo-actionlib, ros-indigo-actionlib-msgs, ros-indigo-costmap-2d, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-message-runtime, ros-indigo-move-base-msgs, ros-indigo-roscpp, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-visualization-msgs
Description: Frontier exploration implementation in ROS, accepts exploration goals via actionlib (Rviz UI provided), sends movement commands to move_base.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-frontier-exploration//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
